from django.db import models
from ordered_model.models import OrderedModel


class Checklist(models.Model):
    pass


class Step(OrderedModel):

    checklist = models.ForeignKey(Checklist, related_name='steps')
    order_with_respect_to = 'checklist'

    description = models.TextField(default='')

    class Meta(OrderedModel.Meta):
        pass


class Worksheet(models.Model):

    checklist = models.ForeignKey(Checklist, related_name='worksheets')


class CompletedStep(models.Model):

    worksheet = models.ForeignKey(Worksheet, related_name='completed_steps')
    step = models.ForeignKey(Step, related_name='completed_set')

    class Meta(object):
        unique_together = ('worksheet', 'step')
