from django.conf import settings
from django.contrib import admin
from django.conf.urls import patterns, include, url
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.views.generic import RedirectView
import django_openid_auth.urls

import djcelery
djcelery.setup_loader()

admin.autodiscover()

urlpatterns = patterns('',
    url(r'^', include('revtracker.urls')),
    url(r'^admin/', include(admin.site.urls)),
    url(r'^openid/', include(django_openid_auth.urls)),
    url(r'^checklist/', include('checklist.urls')),
    # combo view for serving css outside dev/ prefi
    url(r'^combo/rev-\w+/$', 'revtracker.views.combo_view', name='dpa-combo-link'),
    url(r'^combo/$', 'revtracker.views.combo_view', name='dpa-combo'),
    (r'^favicon\.ico$', RedirectView.as_view(url='%s/favicon.ico' % settings.STATIC_URL)),
)

urlpatterns += patterns('',
    (r'^assets/(.*)', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT}),
)

urlpatterns += staticfiles_urlpatterns()
