from django.conf import settings
from launchpadlib.launchpad import Launchpad


class LaunchpadPersonDouble(object):

    def __init__(self, name):
        self.name = name


class LaunchpadPeopleDouble(object):

    def __init__(self):
        self.emails = {}

    def getByEmail(self, email):
        return self.emails.get(email)


class LaunchpadDouble(object):

    def __init__(self):
        self.people = LaunchpadPeopleDouble()


def get_launchpad(launchpadlib_dir):
    if settings.LP_INSTANCE == 'fake':
        return LaunchpadDouble()
    else:
        return Launchpad.login_anonymously(
                'deploy_tracker', service_root=settings.LP_INSTANCE,
                version='1.0', launchpadlib_dir=launchpadlib_dir)
