# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models, migrations
from django.conf import settings


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('checklist', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='DeploymentRequest',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('status', models.IntegerField(default=0, choices=[(0, b'Waiting'), (1, b'Complete')])),
                ('date_created', models.DateTimeField(auto_now_add=True)),
                ('date_completed', models.DateTimeField(null=True, blank=True)),
                ('completer', models.ForeignKey(related_name='completed_deployment_set', blank=True, to=settings.AUTH_USER_MODEL, null=True)),
            ],
            options={
                'ordering': ['date_created', 'project', 'deploy_revision'],
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Project',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('name', models.SlugField(unique=True, max_length=128)),
                ('url', models.CharField(max_length=1024, verbose_name=b'URL')),
                ('git_branch', models.CharField(max_length=512, null=True, verbose_name=b'git branch (leave empty for bzr)', blank=True)),
                ('sourcedeps_path', models.CharField(max_length=512, blank=True)),
                ('no_qa_of_main_branch', models.BooleanField(default=False)),
                ('description', models.TextField(null=True, blank=True)),
            ],
            options={
                'ordering': ['name'],
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Revision',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('revno', models.IntegerField(db_index=True)),
                ('commit_sha1', models.CharField(max_length=40, null=True, blank=True)),
                ('branch', models.CharField(max_length=512, null=True, blank=True)),
                ('status', models.IntegerField(choices=[(0, b'Unknown'), (1, b'Yes'), (2, b'No'), (3, b'Untestable')])),
                ('commit_message', models.TextField()),
                ('assignee', models.CharField(max_length=128, null=True, blank=True)),
                ('link', models.URLField()),
                ('committer', models.ForeignKey(blank=True, to=settings.AUTH_USER_MODEL, null=True)),
                ('parent', models.ForeignKey(related_name='children', blank=True, to='revtracker.Revision', null=True)),
                ('project', models.ForeignKey(to='revtracker.Project')),
                ('rolled_back_by', models.ForeignKey(related_name='rolls_back', blank=True, to='revtracker.Revision', null=True)),
            ],
            options={
                'ordering': ['project', 'branch', '-revno'],
            },
            bases=(models.Model,),
        ),
        migrations.AlterUniqueTogether(
            name='revision',
            unique_together=set([('project', 'branch', 'revno')]),
        ),
        migrations.AddField(
            model_name='project',
            name='deployed_revision',
            field=models.ForeignKey(related_name='+', blank=True, to='revtracker.Revision', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='project',
            name='deployment_checklist',
            field=models.ForeignKey(blank=True, to='checklist.Checklist', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='deploymentrequest',
            name='deploy_revision',
            field=models.ForeignKey(related_name='+', to='revtracker.Revision'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='deploymentrequest',
            name='project',
            field=models.ForeignKey(related_name='deployment_request_set', to='revtracker.Project'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='deploymentrequest',
            name='requester',
            field=models.ForeignKey(related_name='requested_deployment_set', to=settings.AUTH_USER_MODEL),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='deploymentrequest',
            name='start_revision',
            field=models.ForeignKey(related_name='+', blank=True, to='revtracker.Revision', null=True),
            preserve_default=True,
        ),
        migrations.AlterUniqueTogether(
            name='deploymentrequest',
            unique_together=set([('project', 'deploy_revision')]),
        ),
    ]
