YUI.add("isitdeployable-project-info", function (Y) {

    var TEMPLATE_NAME = 'project_info';
    var template = Y.isitdeployable.Templating.compile_template(TEMPLATE_NAME);

    Y.namespace("isitdeployable").ProjectInfo = Y.Base.create("project_info", Y.Widget, [], {
        rerender: function(e) {
            var boundingBox = this.get("boundingBox");
            var html = template(this.get('data'));
            boundingBox.setHTML(html);
        },
        bindUI: function() {
            this.after("dataChange", this.rerender);
            //var holder = this;
            //var project_name = this.get('data').name;
            //this.get('boundingBox').delegate("submit", function(e) {
            //    e.preventDefault();
            //    Y.io('/api/v1/project/' + project_name + '/+set-deployed', holder._get_io_cfg(this));
            //}, '#update_deployed_revision');
        },
        _get_io_cfg: function(form) {
            return {
                method: form.get('method'),
                form: {id: form},
                on: {
                    success: Y.bind(this._update_deployed_success, this),
                    failure: Y.bind(this._update_deployed_failure, this)
                }
            };
        },
        _update_deployed_success: function(id, xhr_response, args) {
            var response = Y.JSON.parse(xhr_response.responseText);
            var data = this.get('data');
            var project_name = data.name;
            if (response.status == 'ok') {
                Y.io('/api/v1/project/' + project_name, {
                    method: 'get',
                    on: {
                        success: Y.bind(this._refresh_project_success, this),
                        failure: Y.bind(this._refresh_project_failure, this)
                    }
                });
            } else {
                data.errors = response.errors;
                this.set('data', data);
            };
        },
        _refresh_project_success: function(id, xhr_response, args) {
            var response = Y.JSON.parse(xhr_response.responseText);
            var csrf_token = response.csrf_token;
            var project = response.project;
            project.csrf_token = csrf_token;
            this.set('data', project);
            this.fire('project_info:deployed_revision_updated', {data: response});
        },
        _refresh_project_failure: function(id, response, args) {
            console.log(response);
            alert("Updating page failed, try refreshing.");
        },
        _update_deployed_failure: function(id, response, args) {
            console.log(response);
            alert("Request failed, please try again.");
        }
    }, {
        ATTRS: {
            data: {
                value: {}
            }
        },
        HTML_PARSER: {
            data: function(contentBox) {
                return Y.JSON.parse(contentBox.getAttribute('data-all'));
            }
        }
    });

}, "0.0.1", { requires: ["base-build", "widget", "handlebars", "json-parse", "isitdeployable-templating", "io-form"] });
